angular.module('Authentication', []);
angular.module('Home', []);
var cApp = angular.module('community-app', ['Authentication','Home','ngCookies','angularFileUpload','community-appFilters','xeditable','community-appServices','ngRoute','ngSanitize','smoothScroll','googleApi']).
  config(['$routeProvider', function($routeProvider) {
  $routeProvider.           
           when('/usr', {templateUrl: 'partials/usr.html',   controller: usrCtrl}).
		   when('/dashboard', {templateUrl: 'partials/dashboard.html',   controller: 'dashboardcontroller'}).
		   when('/view/:username', {templateUrl: 'partials/viewprofile.html',   controller: 'viewuserlistcontroller'}).
		   when('/edit/:username', {templateUrl: 'partials/edituser.html',   controller: edituserlistcontroller}).
		   when('/questions', {templateUrl: 'partials/questionlist.html',   controller: 'questionlistcontroller'}).
		   when('/jobs', {templateUrl: 'partials/jobs.html',   controller: 'jobscontroller'}).
		    when('/content', {templateUrl: 'partials/content.html',   controller: 'contentcontroller'}).
		   when('/riderrequest', {templateUrl: 'partials/ridereq.html',   controller: 'ridereqcontroller'}).
           when('/login', {templateUrl: 'partials/login.html',   controller: 'LoginController'}).
		   otherwise({redirectTo: '/questions'}); 
		   
}]).run(['$rootScope', '$location', '$cookieStore', '$http','CommAppService',
       function ($rootScope, $location, $cookieStore, $http,CommAppService) {
          $rootScope.globals = $cookieStore.get('globals') || '';
          $rootScope.account = $cookieStore.get('account') || '';
}]).config(function(googleLoginProvider) {
    googleLoginProvider.configure({    	
    	clientId:'232396514137-u51obprpdfk373l6uju0d876frq0cgbk.apps.googleusercontent.com',
        scopes: ["https://www.googleapis.com/auth/userinfo.email", "https://www.googleapis.com/auth/calendar", "https://www.googleapis.com/auth/plus.login"]
    });
}).directive('uiDate', function() {
    return {
      require: '?ngModel',
      link: function($scope, element, attrs, controller) {
        var originalRender, updateModel, usersOnSelectHandler;
        if ($scope.uiDate == null) $scope.uiDate = {};
        if (controller != null) {
          updateModel = function(value, picker) {
            return $scope.$apply(function() {
              return controller.$setViewValue(element.datepicker("getDate"));
            });
          };
          if ($scope.uiDate.onSelect != null) {
            usersOnSelectHandler = $scope.uiDate.onSelect;
            $scope.uiDate.onSelect = function(value, picker) {
              updateModel(value);
              return usersOnSelectHandler(value, picker);
            };
          } else {
            $scope.uiDate.onSelect = updateModel;
          }
          originalRender = controller.$render;
          controller.$render = function() {
            originalRender();
            return element.datepicker("setDate", controller.$viewValue);
          };
        }
        return element.datepicker($scope.uiDate);
      }
    };
  }).directive('scrollOnClick', function(mydata) {
  return {
    restrict: 'A',
    link: function(scope, $elm) {
      $elm.on('click', function() {
		   var clicktext = $elm.text();
		   console.log(clicktext);
		   console.log(userlist);
		   var rplce = clicktext.replace(/ /g,'');
		   var sectionname = rplce.toLowerCase();
		   var rplcesectionname = sectionname.replace(/[/,(,)]/g,'');
		  // console.log($scope.mydata);
		//   var strsts = .startsWith(rplcesectionname);
		   $("body,html").animate({scrollTop: $('.'+rplcesectionname).position().top-70}, "slow");
      });
    }
  }
}).directive('animateMe', function() {
   return function(scope, element, attrs) {
      scope.$watch(attrs.animateMe, function() {
         element.slideToggle("fast");
      });
   };
});