angular.module('community-appServices', ['ngResource'])
   .factory('CommAppService', function($resource){    
	var CommAppService = {
			name: "CommAppService",
			
			getChartData : function getChartData($http,url,param,callback) {				
				var config = {headers:  {'app-id': 'appid','app-key' : 'appkey'},params:param};		        
				$http.get(urlBase+url,config).
				    success(function(data, status, headers, config) {
				      callback(data);
				    }).
				    error(function(data, status, headers, config) {
					  callback("Error");
				    });          
		     },
		     postData : function postData($http,url,param,callback) {		    	 
					var config = {headers:  {'app-id': 'appid','app-key' : 'appkey'}};		        
					$http.post(urlBase+url,param,config).
					    success(function(data, status, headers, config) {					  
						  callback(data);
					    }).
					    error(function(data, status, headers, config) {
						  callback("Error");
					    });
	          
			     },
			 putData : function postData($http,url,param,callback) {
						var config = {headers:  {'app-id': 'appid','app-key' : 'appkey'}};		        
						$http.put(urlBase+url,param,config).
						    success(function(data, status, headers, config) {						  
							  callback(data);
						    }).
						    error(function(data, status, headers, config) {
							  callback("Error");
						    });
		          
				     },
			  delData : function postData($http,url,callback) {
							$http({method: 'DELETE', url: urlBase+url,headers:  {'app-id': 'appid','app-key' : 'appkey'}}).
							    success(function(data, status, headers, config) {						  
								  callback(data);
							    }).
							    error(function(data, status, headers, config) {
								  callback("Error");
							    });
			          
					     },
			getPrInfoApi:function getPrInfoApi($scope,$http,url,callback){
			              	 var xdr = new xdRequest();
			              	 xdr.setURL(url); 
			              	 xdr.get(function(response) {
			              		 var el = document.createElement( 'div' );
			              		 el.innerHTML = response.html;
			              		 var urls = [];var ps = [];var pattern = /^https?\:\/\/([^\/?#]+)(?:[\/?#]|$)/i;        		 
			              		 for (var index = 0; index < el.getElementsByTagName( 'img' ).length; index++) {        			 
			              			var item = {};  
			              			 var src = el.getElementsByTagName( 'img' )[index].src;
			              			 item.size = el.getElementsByTagName( 'img' )[index].height*el.getElementsByTagName( 'img' )[index].width;
			              			  
			              			if(src&&src.match("http")){ 
			              				if(src.match(pattern)[0]=="http://test.snap-support.com:8080/"||src.match(pattern)[0]=="http://localhost:8080/"||src.match(pattern)[0]=="http://test.snap-support.com:8080/"){
			              				   var newUrl = src.replace(src.match(pattern)[0],url.match(pattern)[0]).replace('/CommunityAppAdmin/','/'); 
			              				 item.src=newUrl;
			              			   }else{item.src=src;}
			              			 }
			              			urls.push(item);
			              			}
			              		for (var i = 0; i < el.getElementsByTagName( 'p' ).length; i++) {        			 
			              			var item = {};  
			              			var p = el.getElementsByTagName( 'p' )[i];			              			  
			              			ps.push(p.innerHTML);			              			
			              			}
			              		
			              		ps.sort(function(a, b){
			              		  return b.length - a.length; 
			              		});
			              		
			              		function compare(a,b) {
			              		  if (a.size < b.size)
			              		     return 1;
			              		  if (a.size > b.size)
			              		    return -1;
			              		  return 0;
			              		}
			              		urls.sort(compare);
			              		 var description='';
			              		 var metas = el.getElementsByTagName('meta');
			              		 for (var x=0,y=metas.length; x<y; x++) {
			              		   if (metas[x].name.toLowerCase() == "description") {
			              		     description = metas[x];}}
			              		 var data = [];var title = {};var imgUrl={};var ptag={};
			              		 title.title=el.getElementsByTagName( 'title' ).item(0).innerHTML;
			              		 data.push(title);        					
			              		 imgUrl.url=urls;data.push(imgUrl);        				
			              		 ptag.desc=description.content;
			              		 var rex = /(<([^>]+)>)/ig;
			              	     if(ps[0]){ptag.desc_a=ps[0].replace(rex , "").replace(/&nbsp;/g,'');}
			              		 data.push(ptag);
			              		 callback(data);        					
			              	 });
			               },
	};    
    return CommAppService;
}).factory('AuthenticationService',
	    ['Base64', '$http', '$cookieStore', '$rootScope', '$timeout',
	     function (Base64, $http, $cookieStore, $rootScope, $timeout) {
	         var service = {};
	  
	         service.Login = function (param,url,callback) {
	         
	        	 	$http({
						method: "POST",
						url: urlBase+'/login',
						headers: {'API_Key': 'apikey','Content-Type' : 'application/json'},					
						data: param						
					}).
				    success(function(data) {						  
					  callback(data);
				    }).
				    error(function(data) {
					  callback(status);
				    });
	         };
			 
			 service.question = function (url,accessToken,param,callback) {
				 var quesans=[];
	        	 	$http({
						method: "get",
						url: urlBase+url,
						params:param,
						headers: {'API_Key': 'apikey','Content-Type' : 'application/json','accessToken': accessToken},					
						//data: param						
					}).
				    success(function(data) {
					
						//callback(data);
						console.log(data);
						for(var i = 0; i < data.results.length; i++){
							
							var questionid = data.results[i].id;
							var totalcount = data.total_count;
							var question = data.results[i].text;
							var quesname = data.results[i].userModel.firstName;
							var quesimage = data.results[i].userModel.image;
							var createdAt = data.results[i].createdAt;
							var answerCount = data.results[i].answerCount;
							var approved = data.results[i].approved;
							getqueans(data,accessToken,questionid,totalcount,question,quesname,quesimage,createdAt,answerCount,approved);
							
							
						}
							//callback(quesans);
				    }).
				    error(function(data) {
					  callback(status);
				    });

					function getqueans(data,accessToken,questionid,totalcount,question,quesname,quesimage,createdAt,answerCount,approved){
					//	console.log(data);
							//	var questionid = data.results[i].id;		
								$http({
								method: "get",
									url: urlBase+'/classes/answer?where={"questionId":'+questionid+'}',
									headers: {'API_Key': 'apikey','Content-Type' : 'application/json','accessToken': accessToken},					
									//data: param						
								}).
								success(function(data1) {
									
								//	console.log(data1);
									var item={};
									var ansarr = [];
									for(var j = 0;  j < data1.results.length; j++){
										var item1={};
										item1.answer = data1.results[j].text;
										item1.approved = data1.results[j].approved;
										item1.ansid = data1.results[j].id;
										item1.ansname = data1.results[j].userModel.firstName;
										item1.ansimage = data1.results[j].userModel.image;
									//	console.log(item1);
										ansarr.push(item1);
										
									}
									item.questionid = questionid;
									item.totalcount = totalcount;
									item.question = question;
									item.quesname = quesname;
									item.quesimage = quesimage;
									item.createdAt = createdAt;
									item.answerCount = answerCount;
									item.approved = approved;
									item.answer = ansarr; 
									quesans.push(item);	
							//	console.log(quesans);
									if(callback) callback(quesans); 
								})					
										
					}
					};
					
					service.content = function (url,accessToken,param,callback) {
	         
	        	 	$http({
						method: "get",
						url: urlBase+url,
						params:param,
						headers: {'API_Key': 'apikey','Content-Type' : 'application/json','accessToken': accessToken},				
					//	data: param						
					}).
				    success(function(data) {						  
					if(callback)  callback(data);
				    }).
				    error(function(data) {
					  callback(status);
				    });
	         };
			 
			 
			 	service.jobs = function (url,accessToken,callback) {
	         
	        	 	$http({
						method: "get",
						url: urlBase+url,
					//	params:param,
						headers: {'API_Key': 'apikey','Content-Type' : 'application/json','accessToken': accessToken},				
					//	data: param						
					}).
				    success(function(data) {						  
					if(callback)  callback(data);
					console.log(data);
				    }).
				    error(function(data) {
					  callback(status);
				    });
	         };
				
			service.userfind = function (url,fnames,callback) {
	         
	        	 	$http({
						method: "get",
						url: urlBase+'/user?where={"fname":'+fnames+'}',
						headers: {'app-id': 'appid','app-key' : 'appkey'},					
						//data: param						
					}).
				    success(function(data) {
					
						callback(data);
					  

				    }).
				    error(function(data) {
					  callback(status);
				    });
	        };
			
			service.riderrqst = function (url,callback) {
	         
	        	 	$http({
						method: "get",
						url: urlBase+'/classes/riderequests ',
						headers: {'app-id': 'appid','app-key' : 'appkey'},					
						//data: param						
					}).
				    success(function(data) {
						callback(data);
					  

				    }).
				    error(function(data) {
					  callback(status);
				    });
	         };
			 service.riderrqstdash = function (url,callback) {
	         
	        	 	$http({
						method: "get",
						url: urlBase+url,
						headers: {'app-id': 'appid','app-key' : 'appkey'},					
						//data: param						
					}).
				    success(function(data) {
						callback(data);
					  

				    }).
				    error(function(data) {
					  callback(status);
				    });
	         };
			
			 service.userdelete = function (url,accessToken,callback) {
					$http({
						method: "DELETE",
						url: urlBase+url,
						headers: {'API_Key': 'apikey','Content-Type' : 'application/json','accessToken': accessToken},					
					}).
				    success(function(data) {
						callback(data);
					}).
				    error(function(data) {
					  callback(status);
				    });
	         };
			 service.useredit = function (paramL,url,callback) {
				$http({
					method: "POST",
					url: urlBase+url,
					Contenttype: 'application/json',
					headers: {'app-id': 'appid','app-key' : 'appkey'},	
										
					data: paramL						
				}).
				success(function(data) {
					callback(data);
				  

				}).
				error(function(data) {
				  callback(status);
				});
				
				
	         };
			 

			 
	         service.SetCredentials = function (username, password,name,accessToken,uid) {
				 
	             var authdata = Base64.encode(username + ':' + password);
	   
	             $rootScope.globals = {
	                 currentUser: {email:username,username: name,authdata: authdata,accessToken: accessToken}
	             };
				 
             $cookieStore.put('globals', $rootScope.globals);
	         };
	   
	         service.ClearCredentials = function () {
	             $rootScope.globals = '';
	             $cookieStore.remove('globals');
	         };
	   
	         return service;
	     }])
	   
	 .factory('Base64', function () {	   
	     var keyStr = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';	   
	     return {
	         encode: function (input) {
	             var output = "";
	             var chr1, chr2, chr3 = "";
	             var enc1, enc2, enc3, enc4 = "";
	             var i = 0;	   
	             do {
	                 chr1 = input.charCodeAt(i++);
	                 chr2 = input.charCodeAt(i++);
	                 chr3 = input.charCodeAt(i++);	   
	                 enc1 = chr1 >> 2;
	                 enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
	                 enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
	                 enc4 = chr3 & 63;	   
	                 if (isNaN(chr2)) {
	                     enc3 = enc4 = 64;
	                 } else if (isNaN(chr3)) {
	                     enc4 = 64;
	                 }	   
	                 output = output +
	                     keyStr.charAt(enc1) +
	                     keyStr.charAt(enc2) +
	                     keyStr.charAt(enc3) +
	                     keyStr.charAt(enc4);
	                 chr1 = chr2 = chr3 = "";
	                 enc1 = enc2 = enc3 = enc4 = "";
	             } while (i < input.length);	   
	             return output;
	         },
	   
	         decode: function (input) {
	             var output = "";
	             var chr1, chr2, chr3 = "";
	             var enc1, enc2, enc3, enc4 = "";
	             var i = 0;
	   
	             // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
	             var base64test = /[^A-Za-z0-9\+\/\=]/g;
	             if (base64test.exec(input)) {
	                 window.alert("There were invalid base64 characters in the input text.\n" +
	                     "Valid base64 characters are A-Z, a-z, 0-9, '+', '/',and '='\n" +
	                     "Expect errors in decoding.");
	             }
	             input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
	   
	             do {
	                 enc1 = keyStr.indexOf(input.charAt(i++));
	                 enc2 = keyStr.indexOf(input.charAt(i++));
	                 enc3 = keyStr.indexOf(input.charAt(i++));
	                 enc4 = keyStr.indexOf(input.charAt(i++));
	   
	                 chr1 = (enc1 << 2) | (enc2 >> 4);
	                 chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
	                 chr3 = ((enc3 & 3) << 6) | enc4;
	   
	                 output = output + String.fromCharCode(chr1);
	   
	                 if (enc3 != 64) {
	                     output = output + String.fromCharCode(chr2);
	                 }
	                 if (enc4 != 64) {
	                     output = output + String.fromCharCode(chr3);
	                 }
	   
	                 chr1 = chr2 = chr3 = "";
	                 enc1 = enc2 = enc3 = enc4 = "";
	   
	             } while (i < input.length);
	   
	             return output;
	         }
	     };	   
	 });
